/* This is free and unencumbered software released into the public domain. */

abstract class XrResult {
  XrResult._() {}
  static const XR_SUCCESS = 0;
  static const XR_TIMEOUT_EXPIRED = 1;
  static const XR_SESSION_LOSS_PENDING = 3;
  static const XR_EVENT_UNAVAILABLE = 4;
  static const XR_SPACE_BOUNDS_UNAVAILABLE = 7;
  static const XR_SESSION_NOT_FOCUSED = 8;
  static const XR_FRAME_DISCARDED = 9;
  static const XR_ERROR_VALIDATION_FAILURE = -1;
  static const XR_ERROR_RUNTIME_FAILURE = -2;
  static const XR_ERROR_OUT_OF_MEMORY = -3;
  static const XR_ERROR_API_VERSION_UNSUPPORTED = -4;
  static const XR_ERROR_INITIALIZATION_FAILED = -6;
  static const XR_ERROR_FUNCTION_UNSUPPORTED = -7;
  static const XR_ERROR_FEATURE_UNSUPPORTED = -8;
  static const XR_ERROR_EXTENSION_NOT_PRESENT = -9;
  static const XR_ERROR_LIMIT_REACHED = -10;
  static const XR_ERROR_SIZE_INSUFFICIENT = -11;
  static const XR_ERROR_HANDLE_INVALID = -12;
  static const XR_ERROR_INSTANCE_LOST = -13;
  static const XR_ERROR_SESSION_RUNNING = -14;
  static const XR_ERROR_SESSION_NOT_RUNNING = -16;
  static const XR_ERROR_SESSION_LOST = -17;
  static const XR_ERROR_SYSTEM_INVALID = -18;
  static const XR_ERROR_PATH_INVALID = -19;
  static const XR_ERROR_PATH_COUNT_EXCEEDED = -20;
  static const XR_ERROR_PATH_FORMAT_INVALID = -21;
  static const XR_ERROR_PATH_UNSUPPORTED = -22;
  static const XR_ERROR_LAYER_INVALID = -23;
  static const XR_ERROR_LAYER_LIMIT_EXCEEDED = -24;
  static const XR_ERROR_SWAPCHAIN_RECT_INVALID = -25;
  static const XR_ERROR_SWAPCHAIN_FORMAT_UNSUPPORTED = -26;
  static const XR_ERROR_ACTION_TYPE_MISMATCH = -27;
  static const XR_ERROR_SESSION_NOT_READY = -28;
  static const XR_ERROR_SESSION_NOT_STOPPING = -29;
  static const XR_ERROR_TIME_INVALID = -30;
  static const XR_ERROR_REFERENCE_SPACE_UNSUPPORTED = -31;
  static const XR_ERROR_FILE_ACCESS_ERROR = -32;
  static const XR_ERROR_FILE_CONTENTS_INVALID = -33;
  static const XR_ERROR_FORM_FACTOR_UNSUPPORTED = -34;
  static const XR_ERROR_FORM_FACTOR_UNAVAILABLE = -35;
  static const XR_ERROR_API_LAYER_NOT_PRESENT = -36;
  static const XR_ERROR_CALL_ORDER_INVALID = -37;
  static const XR_ERROR_GRAPHICS_DEVICE_INVALID = -38;
  static const XR_ERROR_POSE_INVALID = -39;
  static const XR_ERROR_INDEX_OUT_OF_RANGE = -40;
  static const XR_ERROR_VIEW_CONFIGURATION_TYPE_UNSUPPORTED = -41;
  static const XR_ERROR_ENVIRONMENT_BLEND_MODE_UNSUPPORTED = -42;
  static const XR_ERROR_NAME_DUPLICATED = -44;
  static const XR_ERROR_NAME_INVALID = -45;
  static const XR_ERROR_ACTIONSET_NOT_ATTACHED = -46;
  static const XR_ERROR_ACTIONSETS_ALREADY_ATTACHED = -47;
  static const XR_ERROR_LOCALIZED_NAME_DUPLICATED = -48;
  static const XR_ERROR_LOCALIZED_NAME_INVALID = -49;
  static const XR_ERROR_ANDROID_THREAD_SETTINGS_ID_INVALID_KHR = -1000003000;
  static const XR_ERROR_ANDROID_THREAD_SETTINGS_FAILURE_KHR = -1000003001;
  static const XR_ERROR_CREATE_SPATIAL_ANCHOR_FAILED_MSFT = -1000039001;
  static const XR_RESULT_MAX_ENUM = 0x7FFFFFFF;
}

abstract class XrStructureType {
  XrStructureType._() {}
  static const XR_TYPE_UNKNOWN = 0;
  static const XR_TYPE_API_LAYER_PROPERTIES = 1;
  static const XR_TYPE_EXTENSION_PROPERTIES = 2;
  static const XR_TYPE_INSTANCE_CREATE_INFO = 3;
  static const XR_TYPE_SYSTEM_GET_INFO = 4;
  static const XR_TYPE_SYSTEM_PROPERTIES = 5;
  static const XR_TYPE_VIEW_LOCATE_INFO = 6;
  static const XR_TYPE_VIEW = 7;
  static const XR_TYPE_SESSION_CREATE_INFO = 8;
  static const XR_TYPE_SWAPCHAIN_CREATE_INFO = 9;
  static const XR_TYPE_SESSION_BEGIN_INFO = 10;
  static const XR_TYPE_VIEW_STATE = 11;
  static const XR_TYPE_FRAME_END_INFO = 12;
  static const XR_TYPE_HAPTIC_VIBRATION = 13;
  static const XR_TYPE_EVENT_DATA_BUFFER = 16;
  static const XR_TYPE_EVENT_DATA_INSTANCE_LOSS_PENDING = 17;
  static const XR_TYPE_EVENT_DATA_SESSION_STATE_CHANGED = 18;
  static const XR_TYPE_ACTION_STATE_BOOLEAN = 23;
  static const XR_TYPE_ACTION_STATE_FLOAT = 24;
  static const XR_TYPE_ACTION_STATE_VECTOR2F = 25;
  static const XR_TYPE_ACTION_STATE_POSE = 27;
  static const XR_TYPE_ACTION_SET_CREATE_INFO = 28;
  static const XR_TYPE_ACTION_CREATE_INFO = 29;
  static const XR_TYPE_INSTANCE_PROPERTIES = 32;
  static const XR_TYPE_FRAME_WAIT_INFO = 33;
  static const XR_TYPE_COMPOSITION_LAYER_PROJECTION = 35;
  static const XR_TYPE_COMPOSITION_LAYER_QUAD = 36;
  static const XR_TYPE_REFERENCE_SPACE_CREATE_INFO = 37;
  static const XR_TYPE_ACTION_SPACE_CREATE_INFO = 38;
  static const XR_TYPE_EVENT_DATA_REFERENCE_SPACE_CHANGE_PENDING = 40;
  static const XR_TYPE_VIEW_CONFIGURATION_VIEW = 41;
  static const XR_TYPE_SPACE_LOCATION = 42;
  static const XR_TYPE_SPACE_VELOCITY = 43;
  static const XR_TYPE_FRAME_STATE = 44;
  static const XR_TYPE_VIEW_CONFIGURATION_PROPERTIES = 45;
  static const XR_TYPE_FRAME_BEGIN_INFO = 46;
  static const XR_TYPE_COMPOSITION_LAYER_PROJECTION_VIEW = 48;
  static const XR_TYPE_EVENT_DATA_EVENTS_LOST = 49;
  static const XR_TYPE_INTERACTION_PROFILE_SUGGESTED_BINDING = 51;
  static const XR_TYPE_EVENT_DATA_INTERACTION_PROFILE_CHANGED = 52;
  static const XR_TYPE_INTERACTION_PROFILE_STATE = 53;
  static const XR_TYPE_SWAPCHAIN_IMAGE_ACQUIRE_INFO = 55;
  static const XR_TYPE_SWAPCHAIN_IMAGE_WAIT_INFO = 56;
  static const XR_TYPE_SWAPCHAIN_IMAGE_RELEASE_INFO = 57;
  static const XR_TYPE_ACTION_STATE_GET_INFO = 58;
  static const XR_TYPE_HAPTIC_ACTION_INFO = 59;
  static const XR_TYPE_SESSION_ACTION_SETS_ATTACH_INFO = 60;
  static const XR_TYPE_ACTIONS_SYNC_INFO = 61;
  static const XR_TYPE_BOUND_SOURCES_FOR_ACTION_ENUMERATE_INFO = 62;
  static const XR_TYPE_INPUT_SOURCE_LOCALIZED_NAME_GET_INFO = 63;
  static const XR_TYPE_COMPOSITION_LAYER_CUBE_KHR = 1000006000;
  static const XR_TYPE_INSTANCE_CREATE_INFO_ANDROID_KHR = 1000008000;
  static const XR_TYPE_COMPOSITION_LAYER_DEPTH_INFO_KHR = 1000010000;
  static const XR_TYPE_VULKAN_SWAPCHAIN_FORMAT_LIST_CREATE_INFO_KHR = 1000014000;
  static const XR_TYPE_EVENT_DATA_PERF_SETTINGS_EXT = 1000015000;
  static const XR_TYPE_COMPOSITION_LAYER_CYLINDER_KHR = 1000017000;
  static const XR_TYPE_COMPOSITION_LAYER_EQUIRECT_KHR = 1000018000;
  static const XR_TYPE_DEBUG_UTILS_OBJECT_NAME_INFO_EXT = 1000019000;
  static const XR_TYPE_DEBUG_UTILS_MESSENGER_CALLBACK_DATA_EXT = 1000019001;
  static const XR_TYPE_DEBUG_UTILS_MESSENGER_CREATE_INFO_EXT = 1000019002;
  static const XR_TYPE_DEBUG_UTILS_LABEL_EXT = 1000019003;
  static const XR_TYPE_GRAPHICS_BINDING_OPENGL_WIN32_KHR = 1000023000;
  static const XR_TYPE_GRAPHICS_BINDING_OPENGL_XLIB_KHR = 1000023001;
  static const XR_TYPE_GRAPHICS_BINDING_OPENGL_XCB_KHR = 1000023002;
  static const XR_TYPE_GRAPHICS_BINDING_OPENGL_WAYLAND_KHR = 1000023003;
  static const XR_TYPE_SWAPCHAIN_IMAGE_OPENGL_KHR = 1000023004;
  static const XR_TYPE_GRAPHICS_REQUIREMENTS_OPENGL_KHR = 1000023005;
  static const XR_TYPE_GRAPHICS_BINDING_OPENGL_ES_ANDROID_KHR = 1000024001;
  static const XR_TYPE_SWAPCHAIN_IMAGE_OPENGL_ES_KHR = 1000024002;
  static const XR_TYPE_GRAPHICS_REQUIREMENTS_OPENGL_ES_KHR = 1000024003;
  static const XR_TYPE_GRAPHICS_BINDING_VULKAN_KHR = 1000025000;
  static const XR_TYPE_SWAPCHAIN_IMAGE_VULKAN_KHR = 1000025001;
  static const XR_TYPE_GRAPHICS_REQUIREMENTS_VULKAN_KHR = 1000025002;
  static const XR_TYPE_GRAPHICS_BINDING_D3D11_KHR = 1000027000;
  static const XR_TYPE_SWAPCHAIN_IMAGE_D3D11_KHR = 1000027001;
  static const XR_TYPE_GRAPHICS_REQUIREMENTS_D3D11_KHR = 1000027002;
  static const XR_TYPE_GRAPHICS_BINDING_D3D12_KHR = 1000028000;
  static const XR_TYPE_SWAPCHAIN_IMAGE_D3D12_KHR = 1000028001;
  static const XR_TYPE_GRAPHICS_REQUIREMENTS_D3D12_KHR = 1000028002;
  static const XR_TYPE_SYSTEM_EYE_GAZE_INTERACTION_PROPERTIES_EXT = 1000030000;
  static const XR_TYPE_EYE_GAZE_SAMPLE_TIME_EXT = 1000030001;
  static const XR_TYPE_VISIBILITY_MASK_KHR = 1000031000;
  static const XR_TYPE_EVENT_DATA_VISIBILITY_MASK_CHANGED_KHR = 1000031001;
  static const XR_TYPE_SESSION_CREATE_INFO_OVERLAY_EXTX = 1000033000;
  static const XR_TYPE_EVENT_DATA_MAIN_SESSION_VISIBILITY_CHANGED_EXTX = 1000033003;
  static const XR_TYPE_SPATIAL_ANCHOR_CREATE_INFO_MSFT = 1000039000;
  static const XR_TYPE_SPATIAL_ANCHOR_SPACE_CREATE_INFO_MSFT = 1000039001;
  static const XR_TYPE_VIEW_CONFIGURATION_DEPTH_RANGE_EXT = 1000046000;
  static const XR_TYPE_VIEW_CONFIGURATION_VIEW_FOV_EPIC = 1000059000;
  static const XR_STRUCTURE_TYPE_MAX_ENUM = 0x7FFFFFFF;
}
